package cz.fit.cvut.kadleto2.y36tw2.ejb;

import javax.ejb.Stateless;

/**
 * Implementace stateless EJB prevadi EUR <-> USD.
 * @author tomas
 */
@Stateless
public class CurrencyConverter implements CurrencyConverterRemote {

    /** kurz dolar/euro */
    private double dollarRate = 0.818486124609;
    /** kurz euro/dolar */
    private double euroRate = 1.22176781003;

    /**
     * Prepocita castku v eur do dolaru
     * @param euros - castka v euro k prepocteni
     * @return vyslednou castku v dolarech
     */
    public double eurosToDollars(double euros) {
        return euros*euroRate;
    }

    /**
     * Prepocita castku v dolarech do eur
     * @param dollars - castka v dolarech k prepocteni
     * @return vyslednou castku v eurech
     */
    public double dollarsToEuros(double dollars) {
        return dollars*dollarRate;
    }
 
}
