/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.fit.cvut.kadleto2.y36tw2.ejb;

import cz.fit.cvut.kadleto2.y36tw2.bean.Amount;
import java.util.ArrayList;
import java.util.List;
import javax.ejb.Remove;
import javax.ejb.Stateful;

/**
 * Implementace stateful EJB, pamatuje si historii konverzi konkretniho uzivatele
 * @author tomas
 */
@Stateful
public class History implements HistoryRemote {

    /** kolekce konverzi */
    private List<Amount> conversions;

    /**
     * konstruktor musi inicializovat kolekci, jinak NullPointerException!
     */
    public History() {
        conversions = new ArrayList<Amount>();
    }

    /**
     * ulozi probehlou konverzi do kolekce
     * @param amount - konverze
     */
    public void saveConversion(Amount amount) {
        conversions.add(amount);
    }

    /**
     * vraci kolekci probehlych konverzi
     * @return - kolekce konverzi
     */
    public List<Amount> listConversions() {
        return conversions;
    }

    /**
     * slouzi k likvidaci session bean, je-li z nejakeho duvodu vyzadovana
     * (ukonceni session - at uz klientem nebo JVM)
     */
    @Remove
    public void remove() {
        conversions = null;
    }
    
}
