/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.cvut.fit.kadleto2.y36tw2.web.ctrl;

import cz.fit.cvut.kadleto2.y36tw2.bean.Amount;
import cz.fit.cvut.kadleto2.y36tw2.bean.Currency;
import cz.fit.cvut.kadleto2.y36tw2.ejb.CurrencyConverterRemote;
import cz.fit.cvut.kadleto2.y36tw2.ejb.HistoryRemote;
import java.io.IOException;
import javax.naming.InitialContext;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

/**
 * Servlet obsluhujici formular. Rada veci neni dodelana (zejmena validace vstupu a
 * reseni pripadnych chyb).
 * @author tomas
 */
public class ConverterServlet extends HttpServlet {
   
    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        try {
            // objekt dispecera - predavame rizeni na jsp stranku s formularem
            RequestDispatcher rd = request.getRequestDispatcher("/index.jsp");
            // HTTP session - bude potreba pro ulozeni EJB s historii
            HttpSession session = request.getSession();
            // formular nebyl odeslan, neni session - nedojde k zadnemu zpracovani
            if (request.getParameter("amount") == null || request.getParameter("amount").isEmpty() || session == null)
                rd.forward(request, response);
            // vyhledani EJB pomoci JNDI
            InitialContext context = new InitialContext();
            CurrencyConverterRemote converter = (CurrencyConverterRemote) context.lookup(CurrencyConverterRemote.class.getName());
            // stateful ejb - musime si drzet referenci - a to v HTTP session!
            HistoryRemote history = (HistoryRemote) session.getAttribute("history");
            if (history == null) {
                history = (HistoryRemote) context.lookup(HistoryRemote.class.getName());
                session.setAttribute("history", history);
            }
            // informace o prevodu zapouzdruje objekt Amount
            Amount amount = new Amount();
            amount.setSrcAmount(Double.parseDouble(request.getParameter("amount")));
            if (request.getParameter("currency").compareTo("EUR") == 0) {
                amount.setSrcCurrency(Currency.EUR);
                amount.setDstCurrency(Currency.USD);
                amount.setDstAmount(converter.eurosToDollars(amount.getSrcAmount()));
            }
            else {
                amount.setSrcCurrency(Currency.USD);
                amount.setDstCurrency(Currency.EUR);
                amount.setDstAmount(converter.dollarsToEuros(amount.getSrcAmount()));
            }
            // ulozeni konverze do historie
            history.saveConversion(amount);
            // ulozeni potrebnych dat do request scope
            request.setAttribute("amount", amount);
            request.setAttribute("history", history.listConversions());
            // nakonec se rizeni preda na JSP formular
            rd.forward(request, response);
        }
        catch (Exception e) {
            System.err.println("" + e.getMessage());
        }
    } 

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
